<?php
session_start();
/*
Plugin Name: Inline Upload
Plugin URI: http://www.iptanus.com/?page_id=27
Description: Simple interface to upload files from a page.
Version: 1.6.1
Author: Nickolas Bossinas
Author URI: http://www.iptanus.com
*/

/*
-------****** This plugin is a conversion of Upload Widget plugin of Monpelaud ******-------
*/

/*
Inline Upload (Wordpress Plugin)
Copyright (C) 2010, 2011 Nickolas Bossinas
Contact me at http://www.iptanus.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by          
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

add_shortcode("inline_upload", "inline_upload_handler");
load_plugin_textdomain('inline-upload', false, dirname(plugin_basename (__FILE__)).'/languages');
wp_enqueue_style('inline-upload-style', '/'.PLUGINDIR .'/'.dirname(plugin_basename (__FILE__)).'/css/inline_upload_style.css',false,'1.0','all');
wp_enqueue_script('json_class', WP_CONTENT_URL.'/plugins/'.dirname(plugin_basename (__FILE__)).'/include/json2.js');
wp_enqueue_script('httprequest_script', WP_CONTENT_URL.'/plugins/'.dirname(plugin_basename (__FILE__)).'/include/http_request.js');
add_action('wp_ajax_iu_ajax_action', 'iu_ajax_action_callback');

//define plugin defaults
DEFINE("IU_UPLOADID", "1");
DEFINE("IU_UPLOADTITLE", __('Upload a file', 'inline-upload'));
DEFINE("IU_SELECTBUTTON", __('Select File', 'inline-upload'));
DEFINE("IU_UPLOADBUTTON", __('Upload File', 'inline-upload'));
DEFINE("IU_UPLOADROLE", "administrator");
DEFINE("IU_UPLOADPATH", 'uploads');
DEFINE("IU_CREATEPATH", "false");
DEFINE("IU_UPLOADPATTERNS", "*.*");
DEFINE("IU_MAXSIZE", "10");
DEFINE("IU_ACCESSMETHOD", "normal");
DEFINE("IU_FTPINFO", "");
DEFINE("IU_DUBLICATESPOLICY", "overwrite");
DEFINE("IU_UNIQUEPATTERN", "index");
DEFINE("IU_FILEBASELINK", "false");
DEFINE("IU_NOTIFY", "false");
DEFINE("IU_NOTIFYRECIPIENTS", "");
DEFINE("IU_NOTIFYSUBJECT", __('File Upload Notification', 'inline-upload'));
DEFINE("IU_NOTIFYMESSAGE", __("Dear Recipient,\n\n   This is an automatic delivery message to notify you that a new file has been uploaded.\n\nBest Regards", 'inline-upload'));
DEFINE("IU_ATTACHFILE", "false");
DEFINE("IU_REDIRECT", "false");
DEFINE("IU_REDIRECTLINK", "");
DEFINE("IU_ADMINMESSAGES", "false");
DEFINE("IU_SUCCESSMESSAGE", __('File %filename% uploaded successfully', 'inline-upload'));
DEFINE("IU_SUCCESSMESSAGECOLOR", "green");
DEFINE("IU_SHOWTARGETFOLDER", "false");
DEFINE("IU_TARGETFOLDERLABEL", "Upload Directory");
DEFINE("IU_ASKFORSUBFOLDERS", "false");
DEFINE("IU_SUBFOLDERTREE", "");
DEFINE("IU_FORCECLASSIC", "false");

function inline_upload_handler($incomingfrompost) {
  //process incoming attributes assigning defaults if required
  $incomingfrompost=shortcode_atts(array(
    "uploadid" => IU_UPLOADID,
    "uploadtitle" => IU_UPLOADTITLE,
    "selectbutton" => IU_SELECTBUTTON,
    "uploadbutton" => IU_UPLOADBUTTON,
    "uploadrole" => IU_UPLOADROLE,
    "uploadpath" => IU_UPLOADPATH,
    "createpath" => IU_CREATEPATH,            
    "uploadpatterns" => IU_UPLOADPATTERNS,
    "maxsize" => IU_MAXSIZE,            
    "accessmethod" => IU_ACCESSMETHOD,            
    "ftpinfo" => IU_FTPINFO,            
    "dublicatespolicy" => IU_DUBLICATESPOLICY,            
    "uniquepattern" => IU_UNIQUEPATTERN,            
    "filebaselink" => IU_FILEBASELINK,            
    "notify" => IU_NOTIFY,            
    "notifyrecipients" => IU_NOTIFYRECIPIENTS,            
    "notifysubject" => IU_NOTIFYSUBJECT,            
    "notifymessage" => IU_NOTIFYMESSAGE,            
    "attachfile" => IU_ATTACHFILE,            
    "redirect" => IU_REDIRECT,            
    "redirectlink" => IU_REDIRECTLINK,            
    "adminmessages" => IU_ADMINMESSAGES,            
    "successmessage" => IU_SUCCESSMESSAGE,            
    "successmessagecolor" => IU_SUCCESSMESSAGECOLOR,            
    "showtargetfolder" => IU_SHOWTARGETFOLDER,            
    "targetfolderlabel" => IU_TARGETFOLDERLABEL,            
    "askforsubfolders" => IU_ASKFORSUBFOLDERS,            
    "subfoldertree" => IU_SUBFOLDERTREE,            
    "forceclassic" => IU_FORCECLASSIC            
  ), $incomingfrompost);
  //run function that actually does the work of the plugin
  $inline_upload_output = inline_upload_function($incomingfrompost);
  //send back text to replace shortcode in post
  return $inline_upload_output;
}

function iu_upload_plugin_clean($label) {
	/**
	 * Regular expressions to the change some characters.
	 */

	$search = array ('@[eeeeEE]@i','@[aaaAA]@i','@[iiII]@i','@[uuuUU]@i','@[ooOO]@i',
	'@[c]@i','@[^a-zA-Z0-9._]@');	 
	$replace = array ('e','a','i','u','o','c','-');
	$label =  preg_replace($search, $replace, $label);
	$label = strtolower($label); // Convert in lower case
	return $label;
}

function iu_upload_plugin_full_path( $path ) {
	if ($path) {
		if ( substr($path, 0, 1) == "/" ) $path = substr($path, 1, strlen($path) - 1);
		if ( substr($path, -1, 1) == "/" ) $path = substr($path, 0, strlen($path) - 1);
		$full_upload_path = WP_CONTENT_DIR.'/'.$path.'/'; }
	else {
		$full_upload_path = WP_CONTENT_DIR.'/uploads/';
	}
	return $full_upload_path;
}

function iu_upload_plugin_directory( $path ) {
	$dirparts = explode("/", $path);
	return $dirparts[count($dirparts) - 1];
}

function iu_upload_plugin_wildcard_to_preg($pattern) {
	return '/^' . str_replace(array('\*', '\?', '\[', '\]'), array('.*', '.', '[', ']+'), preg_quote($pattern)) . '$/is';
}



function iu_upload_plugin_wildcard_match($pattern, $str) {
	$pattern = iu_upload_plugin_wildcard_to_preg($pattern);
	return preg_match($pattern, $str);
}

function iu_create_directory($path, $method, $ftpdata, $adminmessages) {
	if ( $method == "" || $method == "normal" ) {
		mkdir($path, 0777, true);
	}
	else if ( $method == "ftp" && $ftpdata != "" ) {
		$ftpdata_flat =  str_replace(array('\:', '\@'), array('\_', '\_'), $ftpdata);
		$pos1 = strpos($ftpdata_flat, ":");
		$pos2 = strpos($ftpdata_flat, "@");
		if ( $pos1 && $pos2 && $pos2 > $pos1 ) {
			$ftp_username = substr($ftpdata, 0, $pos1);
			$ftp_password = substr($ftpdata, $pos1 + 1, $pos2 - $pos1 - 1);
			$ftp_host = substr($ftpdata, $pos2 + 1);
			$conn_id = ftp_connect($ftp_host);
			$login_result = ftp_login($conn_id, $ftp_username, $ftp_password);
			if ( $conn_id && $login_result ) {
				$flat_host = preg_replace("/^(.*\.)?([^.]*\..*)$/", "$2", $ftp_host);
				$pos1 = strpos($path, $flat_host);
				if ( $pos1 ) {
					$path = substr($path, $pos1 + strlen($flat_host));
					ftp_mkdir($conn_id, $path);
					ftp_chmod($conn_id, 511, $path);
				}
				else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Could not resolve ftp target filedir. Check the domain in 'ftpinfo' attribute.", "inline-upload").'</strong></font>'; 
			}
			else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Invalid ftp information. Check 'ftpinfo' attribute.", "inline-upload").'</strong></font>';
			ftp_quit($conn_id);
		}
		else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Could not extract ftp information from 'ftpinfo' attribute. Check its syntax.", "inline-upload").'</strong></font>';
	}		
}


function iu_upload_file($source, $target, $method, $ftpdata, $adminmessages) {
	if ( $method == "" || $method == "normal" ) {
		return move_uploaded_file($source, $target);
	}
	else if ( $method == "ftp" &&  $ftpdata != "" ) {
		$result = false;
		$ftpdata_flat =  str_replace(array('\:', '\@'), array('\_', '\_'), $ftpdata);
		$pos1 = strpos($ftpdata_flat, ":");
		$pos2 = strpos($ftpdata_flat, "@");
		if ( $pos1 && $pos2 && $pos2 > $pos1 ) {
			$ftp_username = substr($ftpdata, 0, $pos1);
			$ftp_password = substr($ftpdata, $pos1 + 1, $pos2 - $pos1 - 1);
			$ftp_host = substr($ftpdata, $pos2 + 1);
			$conn_id = ftp_connect($ftp_host);
			$login_result = ftp_login($conn_id, $ftp_username, $ftp_password);
			if ( $conn_id && $login_result ) {
				$flat_host = preg_replace("/^(.*\.)?([^.]*\..*)$/", "$2", $ftp_host);
				$pos1 = strpos($target, $flat_host);
				if ( $pos1 ) {
					$temp_fname = tempnam(dirname($target), "tmp");
					move_uploaded_file($source, $temp_fname);
					$target = substr($target, $pos1 + strlen($flat_host));
					$result = ftp_put($conn_id, $target, $temp_fname, FTP_BINARY);
					ftp_chmod($conn_id, 511, $target);
					unlink($temp_fname);
				}
				else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Could not resolve ftp target filename. Check the domain in 'ftpinfo' attribute.", "inline-upload").'</strong></font>';
			}
			else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Invalid ftp information. Check 'ftpinfo' attribute.", "inline-upload").'</strong></font>';
			ftp_quit($conn_id);
		}
		else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Could not extract ftp information from 'ftpinfo' attribute. Check its syntax.", "inline-upload").'</strong></font>';
		return $result;
	}		
}

function iu_plugin_encode_string($string) {
	$array = unpack('C*', $string);
	$new_string = "";	
	for ($i = 1; $i <= count($array); $i ++) {
		$new_string .= sprintf("%02X", $array[$i]);
	}
	return $new_string;
}

function iu_plugin_decode_string($string) {
	$new_string = "";	
	for ($i = 0; $i < strlen($string); $i += 2 ) {
		$new_string .= sprintf("%c", hexdec(substr($string, $i ,2)));
	}
	return $new_string;
}

function iu_plugin_parse_array($source) {
	$keys = array_keys($source);
	$new_arr = array();
	for ($i = 0; $i < count($keys); $i ++) 
		$new_arr[$keys[$i]] = wp_specialchars_decode($source[$keys[$i]]);
	return $new_arr;
}

function iu_create_random_string($len) {
	$base = 'ABCDEFGHKLMNOPQRSTWXYZabcdefghjkmnpqrstwxyz123456789';
	$max = strlen($base) - 1;
	$activatecode = '';
	mt_srand((double)microtime()*1000000);
	while (strlen($activatecode) < $len)
		$activatecode .= $base{mt_rand(0, $max)};
	return $activatecode;
}

function iu_get_user_role($user, $param_role) {
	if ( !empty( $user->roles ) && is_array( $user->roles ) ) {
		/* Go through the array of the roles of the current user */
		foreach ( $user->roles as $user_role )
		/* If one role of the current user matches to the role allowed to upload */
		if ( $user_role == $param_role || $user_role == 'administrator' ) {
			/*  We affect this role to current user */
			$result_role = $user_role;
			break;
		}
		else {
			/* We affect the 'visitor' role to current user */
			$result_role = 'visitor';
		}
	}
	else {
		$result_role = 'visitor';
	}
	return $result_role;		
}

function iu_generate_current_params_index($shortcode_id, $user_login) {
	global $post;
	$cur_index_str = '||'.$post->ID.'||'.$shortcode_id.'||'.$user_login;
	$cur_index_str_search = '\|\|'.$post->ID.'\|\|'.$shortcode_id.'\|\|'.$user_login;
	$index_str = get_option('iu_params_index');
	$index = explode("&&", $index_str);
	foreach ($index as $key => $value) if ($value == "") unset($index[$key]);
	$index_match = preg_grep("/".$cur_index_str_search."$/", $index);
	if ( count($index_match) == 1 && $index_match[0] == "" ) unset($index_match[0]);
	if ( count($index_match) <= 0 ) {
		$cur_index_rand = iu_create_random_string(16);
		array_push($index, $cur_index_rand.$cur_index_str);
	}
	else {
		$cur_index_rand = substr(current($index_match), 0, 16);
		if ( count($index_match) > 1 ) {
			$index_match_keys = array_keys($index_match);
			for ($i = 1; $i < count($index_match); $i++) {
				$ii = $index_match_keys[$i];
				unset($index[array_search($index_match[$ii], $index, true)]);
			}
		}
	}
	if ( count($index_match) != 1 ) {
		$index_str = implode("&&", $index);
		update_option('iu_params_index', $index_str);
	}
	return $cur_index_rand;
}

function iu_get_params_fields_from_index($params_index) {
	$fields = array();
	$index_str = get_option('iu_params_index');
	$index = explode("&&", $index_str);
	$index_match = preg_grep("/^".$params_index."/", $index);
	if ( count($index_match) == 1 && $index_match[0] == "" ) unset($index_match[0]);
	if ( count($index_match) > 0 )
		list($fields['unique_id'], $fields['page_id'], $fields['shortcode_id'], $fields['user_login']) = explode("||", current($index_match));
	return $fields; 
}

function iu_encode_array_to_string($arr) {
	$arr_str = json_encode($arr);
	$arr_str = iu_plugin_encode_string($arr_str);
	return $arr_str;
}

function iu_decode_array_from_string($arr_str) {
	$arr_str = iu_plugin_decode_string($arr_str);
	$arr = json_decode($arr_str, true);
	return $arr;
}

//use wp_specialchars_decode so html is treated as html and not text
//use wp_specialchars when outputting text to ensure it is valid html

function inline_upload_function($incomingfromhandler) {
	global $post;
	$params = iu_plugin_parse_array($incomingfromhandler);
	$user = wp_get_current_user();

	$uploadform = 'uploadform_'.$params["uploadid"];
	$uploadedfile = 'uploadedfile_'.$params["uploadid"];
	$upfile = 'upfile_'.$params["uploadid"];
	$selectsubdir = 'selectsubdir_'.$params["uploadid"];
	$hiddeninput = 'hiddeninput_'.$params["uploadid"];
	$upload = 'upload_'.$params["uploadid"];
	$upload_type = "submit";
	$upload_onclick = ' onclick="iu_FormButtonPressed('.$params["uploadid"].')"';
	$textfile = 'fileName_'.$params["uploadid"];
	$input = 'input_'.$params["uploadid"];
	$message_label = 'messagelabel_'.$params["uploadid"];
	$progress_bar = 'progressbar_'.$params["uploadid"];

	//check if user is allowed to view plugin, otherwise do not generate it
	$plugin_upload_user_role = iu_get_user_role($user, $params["uploadrole"]);		
	if ( $plugin_upload_user_role != $params["uploadrole"] && $plugin_upload_user_role != 'administrator' && $params["uploadrole"] != 'all' ) return;

	$params["adminmessages"] = ( $params["adminmessages"] == "true" && $plugin_upload_user_role == 'administrator' );

	/* Define dynamic upload path from variables */
	$search = array ('/%username%/');	 
	$replace = array ($user->user_login);
	$params["uploadpath"] =  preg_replace($search, $replace, $params["uploadpath"]);

	/* Show information about directory or select target subdirectory */
	$inline_upload_output_subfolders = "";	
	if ( $params["askforsubfolders"] == "true" ) {
		$subfolders = explode(",", $params["subfoldertree"]);
		if ( count($subfolders) == 0 ) { $subfolders = array ( iu_upload_plugin_directory($params["uploadpath"]) ); }
		if ( count($subfolders) == 1 && trim($subfolders[0]) == "" ) { $subfolders = array ( iu_upload_plugin_directory($params["uploadpath"]) ); }
		$inline_upload_output_subfolders .= '<p style="padding: 0px; margin: 0px;"><span>'.$params["targetfolderlabel"].' </span><select id="'.$selectsubdir.'" onchange="javascript: document.getElementById(\''.$hiddeninput.'\').value = document.getElementById(\''.$selectsubdir.'\').selectedIndex;">';
		$dir_levels = array ( iu_upload_plugin_directory($params["uploadpath"]) );
		$subfolder_paths = array ( );
		$prev_level = 0;
		foreach ($subfolders as $subfolder) {
			$subfolder = trim($subfolder);			
			$star_count = 0;
			$start_spaces = "";
			while ( $star_count < strlen($subfolder) ) {
				if ( substr($subfolder, $star_count, 1) == "*" ) {
					$star_count ++;
					$start_spaces .= "&nbsp;&nbsp;&nbsp;";
				}
				else break;
			}
			if ( $star_count - $prev_level <= 1 ) {
				$subfolder = substr($subfolder, $star_count, strlen($subfolder) - $star_count);
				$subfolder_items = explode('/', $subfolder);
				if ( $subfolder_items[1] != "" ) {
					$subfolder_dir = $subfolder_items[0];
					$subfolder_label = $subfolder_items[1];
				}
				else {
					$subfolder_dir = $subfolder;
					$subfolder_label = $subfolder;
				}
				if ( count($dir_levels) > $star_count ) $dir_levels[$star_count] = $subfolder_dir;
				else array_push($dir_levels, $subfolder_dir);
				$subfolder_path = "";
				for ( $i_count = 1; $i_count <= $star_count; $i_count++) {
					$subfolder_path .= $dir_levels[$i_count].'/';
				}
				array_push($subfolder_paths, $subfolder_path);
				$inline_upload_output_subfolders .= '<option>'.$start_spaces.$subfolder_label.'</option>';
				$prev_level = $star_count;
			}
		}
		$inline_upload_output_subfolders .= '</select></p>';
	}
	else if ( $params["showtargetfolder"] == "true" ) {
		$upload_directory = iu_upload_plugin_directory($params["uploadpath"]);
		$inline_upload_output_subfolders .= '<p style="padding: 0px; margin: 0px;"><span>'.$params["targetfolderlabel"].': <strong>'.$upload_directory.'</strong></span></p>';
	}

//	below this line no other changes to params array are allowed
//____________________________________________________________________________________________________________________________________________________________________________________

	if ( $params['forceclassic'] != "true" ) {	
//**************section to put additional options inside params array**************
		$params['subfoldersarray'] = $subfolder_paths;
		$params['subdir_selection_index'] = "-1";
//**************end of section of additional options inside params array**************


//**************section to save params as Wordpress options**************
//		every params array is indexed (uniquely identified) by three fields:
//			- the page that contains the shortcode
//			- the id of the shortcode instance (because there may be more than one instances of the shortcode inside a page)
//			- the user that views the plugin (because some items of the params array are affected by the user name)
//		the wordpress option "iu_params_index" holds an array of combinations of these three fields, together with a randomly generated string that corresponds to these fields.
//		the wordpress option "iu_params_xxx", where xxx is the randomly generated string, holds the params array (encoded to string) that corresponds to this string.
//		the structure of the "iu_params_index" option is as follows: "a1||b1||c1||d1&&a2||b2||c2||d2&&...", where
//			- a is the randomly generated string (16 characters)
//			- b is the page id
//			- c is the shortcode id
//			- d is the user name
		$params_index = iu_generate_current_params_index($params["uploadid"], $user->user_login);
		$params_str = iu_encode_array_to_string($params);
		update_option('iu_params_'.$params_index, $params_str);
		$upload_type = "button";
		$ajax_params['shortcode_id'] = $params["uploadid"];
		$ajax_params['params_index'] = $params_index;
		$ajax_params_str = iu_encode_array_to_string($ajax_params);
		$upload_onclick = ' onclick="iu_HTML5UploadFile('.$params["uploadid"].', \''.$ajax_params_str.'\')"';
	}

	/* Display the title if one was input. */
	if ( $params["uploadtitle"] ) {
		$inline_upload_output .= '<p style="margin-bottom: 0px;">'.$params["uploadtitle"].'</p>';
	}
	/* Display the upload form. */
	$inline_upload_output .= '<p style="height: 1px; padding: 0px; margin: 0px; line-height: 0px;"></p>';
	$inline_upload_output .= "\n".'<input type="text" id="'.$textfile.'" class="file_input_textbox" readonly="readonly"/>';		
	$inline_upload_output .= "\n".'<div class="file_input_div">';  
	$inline_upload_output .= "\n\t".'<form id="'.$uploadform.'" name="'.$uploadform.'" method="post" enctype="multipart/form-data">';		
	$inline_upload_output .= "\n\t\t".'<input align="center" type="button" id="'.$input.'" value="'.$params["selectbutton"].'" class="file_input_button"/>';
	$inline_upload_output .= "\n\t\t".'<input type="file" class="file_input_hidden" name="'.$uploadedfile.'" id="'.$upfile.'" tabindex="1" onchange="javascript: document.getElementById(\''.$textfile.'\').value = this.value.replace(/c:\\\\fakepath\\\\/i, \'\')" onmouseout="javascript: document.getElementById(\''.$input.'\').className = \'file_input_button\'" onmouseover="javascript: document.getElementById(\''.$input.'\').className = \'file_input_button_hover\'" onclick="javascript: document.getElementById(\''.$message_label.'\').innerHTML = \'\'; document.getElementById(\''.$message_label.'\').style.visibility=\'collapse\';"/>';
	$inline_upload_output .= "\n\t\t".'<input align="center" type="'.$upload_type.'" id="'.$upload.'" name="'.$upload.'" value="'.$params["uploadbutton"].'" class="file_input_submit"'.$upload_onclick.' />';
	$inline_upload_output .= "\n\t\t".'<input type="hidden" id="'.$hiddeninput.'" name="'.$hiddeninput.'" value="" />';
	$inline_upload_output .= "\n\t".'</form>';
	$inline_upload_output .= "\n".'</div>'; 
	$inline_upload_output .= '<p style="height: 1px; padding: 0px; margin: 0px; line-height: 0px;"></p>';
	$inline_upload_output .= $inline_upload_output_subfolders;
	$inline_upload_output .= '<div id="'.$progress_bar.'" class="file_progress_bar_hidden"><img id="'.$progress_bar.'_inner'.'" class="file_progress_bar_inner_hidden"></img></div>';
	$inline_upload_output .= '<span id='.$message_label.' style="visibility:collapse"></span>';

//	The plugin uses sessions in order to detect if the page was loaded due to file upload or
//	because the user pressed the Refresh button (or F5) of the page.
//	In the second case we do not want to perform any file upload, so we abort the rest of the script.
	if ( $_SESSION['iu_check_refresh_'.$params["uploadid"]] != "form button pressed" ) {
		$_SESSION['iu_check_refresh_'.$params["uploadid"]] = 'do not process';
		return $inline_upload_output."\n";
	}
	$_SESSION['iu_check_refresh_'.$params["uploadid"]] = 'do not process';

//	The plugin uses two ways to upload the file:
//		- The first one uses classic functionality of an HTML form (highest compatibility with browsers but few capabilities).
//		- The second uses ajax (HTML5) functionality (medium compatibility with browsers but many capabilities, like no page refresh and progress bar).
//	The plugin loads using ajax functionality by default, however if it detects that ajax functionality is not supported, it will automatically switch to classic functionality. 
//	The next line checks to see if the form was submitted using ajax or classic functionality.
//	If the uploaded file variable stored in $_FILES ends with "_redirected", then it means that ajax functionality is not supported and the plugin must switch to classic functionality. 
	if ( isset($_FILES[$uploadedfile.'_redirected']) ) $params['forceclassic'] = "true";

	if ( $params['forceclassic'] != "true" ) return $inline_upload_output."\n";

	$params['subdir_selection_index'] = -1;
	if ( isset( $_POST[$hiddeninput] ) ) $params['subdir_selection_index'] = $_POST[$hiddeninput];

	$inline_upload_output .= iu_process_file($params, 'no_ajax');

	return $inline_upload_output."\n";
}

function iu_process_file($params, $method) {
	$user = wp_get_current_user();
	$upload_path_ok = false;
	$allowed_file_ok = false;
	$size_file_ok = false;
	$uploadedfile = 'uploadedfile_'.$params["uploadid"];
	$hiddeninput = 'hiddeninput_'.$params["uploadid"];
	$allowed_patterns = explode(",",$params["uploadpatterns"]);
	$params_output = "";
	$params_output_array['shortcode_id'] = $params["uploadid"];
	$params_output_array['color'] = "black";
	$params_output_array['message'] = "";

	if ( isset($_FILES[$uploadedfile.'_redirected']) ) $uploadedfile .= '_redirected';

	if ( $params["askforsubfolders"] == "true" && $params['subdir_selection_index'] >= 0 ) {
		if ( substr($params["uploadpath"], -1, 1) == "/" ) $params["uploadpath"] .= $params['subfoldersarray'][$params['subdir_selection_index']];
		else $params["uploadpath"] .= '/'.$params['subfoldersarray'][$params['subdir_selection_index']];
	}

	/* Get uploaded file size in Mbytes */
	$upload_file_size = filesize($_FILES[$uploadedfile]['tmp_name']) / 1024 /1024;

	if ( $upload_file_size > 0 ) {

		/* Check if upload path exist */
		if ( is_dir( iu_upload_plugin_full_path($params["uploadpath"]) ) ) {		
			$upload_path_ok = true;
		}
		else if ( $params["createpath"] == "true" ) {
			iu_create_directory(iu_upload_plugin_full_path($params["uploadpath"]), $params["accessmethod"], $params["ftpinfo"], $params["adminmessages"]);
			if ( is_dir( iu_upload_plugin_full_path($params["uploadpath"]) ) ) {		
				$upload_path_ok = true;
			}
		}

		/* File name control */
		foreach ($allowed_patterns as $allowed_pattern) {
			if ( iu_upload_plugin_wildcard_match( $allowed_pattern, $_FILES[$uploadedfile]['name']) ) {
				$allowed_file_ok = true;
				break ;
			}
		}

		/* File size control */
		if ( $upload_file_size <= $params["maxsize"] ) {
			$size_file_ok = true;
		}
	
		if ( !$upload_path_ok or !$allowed_file_ok or !$size_file_ok ) {
			$message_text = '<strong>'.__("Upload failed !", "inline-upload").'</strong>';

			$params_output .=  '<font color="red">'.$message_text.'</font>';
			$params_output_array['color'] = 'red';
			$params_output_array['message'] .= $message_text;
		
			if ( !$upload_path_ok ) {
				$message_text = '<strong>'.'<br />'.__("Targer folder ", "inline-upload").iu_upload_plugin_full_path($params["uploadpath"]).__(" doesn't exist !", "inline-upload").'</strong>';
				$params_output .=  '<font color="red">'.$message_text.'</font>';
				$params_output_array['color'] = 'red';
				$params_output_array['message'] .= $message_text;
			}
		
			if ( !$allowed_file_ok ) {
				$message_text = '<strong>'.'<br />'.__("File not allowed", "inline-upload").'</strong>';
				$params_output .=  '<font color="red">'.$message_text.'</font>';
				$params_output_array['color'] = 'red';
				$params_output_array['message'] .= $message_text;
			}

			if ( !$size_file_ok ) {
				$message_text = '<strong>'.'<br />'.__("File size : ", "inline-upload").$params["maxsize"].' Mb</strong>';
				$params_output .=  '<font color="red">'.$message_text.'</font>';
				$params_output_array['color'] = 'red';
				$params_output_array['message'] .= $message_text;
			}
		}
	}
	else {
//		$message_text = '<strong>'.__("Upload failed !.", "inline-upload").'</strong>';
//		$params_output .=  '<font color="red">'.$message_text.'</font>';
//		$params_output_array['color'] = 'red';
//		$params_output_array['message'] .= $message_text;
//		$message_text = '<strong>'.'<br />'.__("No file selected or file is empty", "inline-upload").'</strong>';
//		$params_output .=  '<font color="red">'.$message_text.'</font>';
//		$params_output_array['message'] .= $message_text;
	}

	if ( $upload_path_ok and $allowed_file_ok and $size_file_ok ) {

		if ( is_uploaded_file($_FILES[$uploadedfile]['tmp_name']) ) {
	
			if ( $allowed_file_ok and $size_file_ok ) {
				$file_copied = false;
				$message_processed = false;
				$source_path = $_FILES[$uploadedfile]['tmp_name'];
				$only_filename = iu_upload_plugin_clean( $_FILES[$uploadedfile]['name'] );
				$target_path = iu_upload_plugin_full_path($params["uploadpath"]).$only_filename;

				$search = array ('/%filename%/', '/%filepath%/');	 
				$replace = array ($only_filename, $target_path);
				$success_message =  preg_replace($search, $replace, $params["successmessage"]);

				if ($source_path) {
					$file_exists = file_exists($target_path);
					if ( !$file_exists || $params["dublicatespolicy"] == "" || $params["dublicatespolicy"] == "overwrite" ) {
						$file_copied = iu_upload_file($source_path, $target_path, $params["accessmethod"], $params["ftpinfo"], $params["adminmessages"]);
					}
					else if ( $file_exists && $params["dublicatespolicy"] == "maintain both" ) {
						$full_path = iu_upload_plugin_full_path($params["uploadpath"]);
						$name_part = $only_filename;
						$ext_part = "";
						$dot_pos = strrpos($name_part, ".");
						if ( $dot_pos ) {
							$ext_part = substr($name_part, $dot_pos);
							$name_part = substr($name_part, 0, $dot_pos);
						}
						if ( $params["uniquepattern"] != "datetimestamp" ) {
							$unique_id = 1;
							do {
								$unique_id += 1;
								$only_filename = $name_part . "(" . $unique_id . ")" . $ext_part;
								$target_path = $full_path . $only_filename;
							}
							while ( file_exists($target_path) );
						}
						else {
							$current_datetime = gmdate("U") - 1;
							do {
								$current_datetime += 1;
								$only_filename = $name_part . "-" . gmdate("YmdHis", $current_datetime) . $ext_part;
								$target_path = $full_path . $only_filename;
							}
							while ( file_exists($target_path) );
						}
						$file_copied = iu_upload_file($source_path, $target_path, $params["accessmethod"], $params["ftpinfo"], $params["adminmessages"]);
						if ( $file_copied ) {
							$message_text = '<strong>'.$success_message.'</strong>';
							$params_output .= '<font color="'.$params["successmessagecolor"].'">'.$message_text.'</font>';
							$params_output_array['color'] = $params["successmessagecolor"];
							$params_output_array['message'] .= $message_text;
							$message_processed = true;
						}
					}
					else {
						$message_text = '<strong>'.__("Upload skipped! File already exists.", "inline-upload").'</strong>';
						$params_output .=  '<font color="red">'.$message_text.'</font>';
						$params_output_array['color'] = 'red';
						$params_output_array['message'] .= $message_text;
						$message_processed = true;
						$file_copied = false;
					}
				}

				if ( $file_copied ) {
					if ( $params["filebaselink"] == "true" ) {			
						$filebaseurl = WP_SITEURL;
						if ( substr($filebaseurl, -1, 1) == "/" ) $filebaseurl = substr($filebaseurl, 0, strlen($filebaseurl) - 1);
						$filebaseurl .= "/wp-admin/tools.php?page=wpfilebase&action=sync&hash_sync=1";					
						echo "<script language=javascript>iu_RunWPFileBaseHttpRequest('" . $filebaseurl . "')</script>"; 
					} 
	
					if ( $params["notify"] == "true" && $params["notifyrecipients"] != "" ) {				
						$search = array ('/%username%/', '/%filename%/', '/%filepath%/');	 
						$replace = array ($user->user_login, $only_filename, $target_path);
						$notifysubject =  preg_replace($search, $replace, $params["notifysubject"]);
						$notifymessage =  preg_replace($search, $replace, $params["notifymessage"]);
						if ( $params["attachfile"] == "true" ) {
							$attachments = array ($target_path);
							wp_mail($params["notifyrecipients"], $notifysubject, $notifymessage, '', $attachments); 
						}
						else {
							wp_mail($params["notifyrecipients"], $notifysubject, $notifymessage); 
						}
					} 

					if ( $params["redirect"] == "true" && $params["redirectlink"] != "" ) {
						echo "<script language=javascript>iu_Redirect('" . $params["redirectlink"] . "')</script>"; 
					}
					else if ( !$message_processed ) {
						$message_text = '<strong>'.$success_message.'</strong>';
						$params_output .= '<font color="'.$params["successmessagecolor"].'">'.$message_text.'</font>';
						$params_output_array['color'] = $params["successmessagecolor"];
						$params_output_array['message'] .= $message_text;
					}
				}
				else if ( !$message_processed ) {
					$message_text = '<strong>'.__("Upload failed ! Unknown error.", "inline-upload").'</strong>';
					$params_output .=  '<font color="red">'.$message_text.'</font>';
					$params_output_array['color'] = 'red';
					$params_output_array['message'] .= $message_text;
				}

				/* Delete temporary file (in "/xampp/tmp/") */
//				unlink($source_path);			
			}
		}
		else {
			$message_text = '<strong>'.__("Upload failed ! Unknown error.", "inline-upload").'</strong>';
			$params_output .=  '<font color="red">'.$message_text.'</font>';
			$params_output_array['color'] = 'red';
			$params_output_array['message'] .= $message_text;
		}
	}

	$params_output .= "\n";

	if ( $method == 'no_ajax' ) return $params_output;
	else return iu_encode_array_to_string($params_output_array);
}

function iu_ajax_action_callback() {
	$user = wp_get_current_user();
	$arr = iu_get_params_fields_from_index($_POST['params_index']);
	if ( $user->user_login != $arr['user_login'] ) die();

	$params_str = get_option('iu_params_'.$arr['unique_id']);
	$params = iu_decode_array_from_string($params_str);
	$params['subdir_selection_index'] = $_POST['subdir_sel_index'];
	$_SESSION['iu_check_refresh_'.$params["uploadid"]] = 'do not process';

	echo iu_process_file($params, 'ajax');
	die(); 
}

?>
